SystemOrganization addCategory: #SlotIntegrationInPharo30!

!MCPackageLoader methodsFor: '*SlotIntegrationInPharo30' stamp: 'MartinDias 7/25/2013 14:36'!
handleLoadErrorsDuring: aBlock
	[aBlock
		on: InMidstOfFileinNotification do: [ :notification | notification resume: true ]]
		on: SlotClassBuilderWarning do: [ :error | error resume ]! !

!SystemNavigationTest methodsFor: '*SlotIntegrationInPharo30-testing' stamp: 'MartinDias 8/7/2013 18:44'!
testAllSendersOfASelectorInAClass
	| senders selector inClass |
	selector := #nextPutAll:.
	inClass := True.
	senders := self systemNavigationToTest allSendersOf: selector inClass: inClass.
	self assert: senders size = 1.
	senders do: [ :methodRef | 
		self assert: methodRef className = inClass name
	].
	#(1 #printOn:) pairsDo: [ :index :selectorRef |
		self assert: ((senders at: index) selector = selectorRef)
	]! !

!TBehavior methodsFor: '*SlotIntegrationInPharo30-private' stamp: 'MartinDias 8/7/2013 17:35'!
becomeCompact
	"Make me compact.
	This means: 
	- find a free slot in 'Smalltalk compactClassArray'
	- add me in that array
	- update my format with the index
	- update my instances
	"

	self classBuilder becomeCompact: self! !

!TBehavior methodsFor: '*SlotIntegrationInPharo30-private' stamp: 'MartinDias 8/7/2013 17:21'!
becomeCompactSimplyAt: index
	"The same as #becomeCompact but without updating my instances."

	self classBuilder becomeCompact: self simplyAt: index! !

!TBehavior methodsFor: '*SlotIntegrationInPharo30-private' stamp: 'MartinDias 8/7/2013 17:27'!
becomeUncompact
	"The inverse of #becomeCompact. However, some classes can not be uncompact: see #checkCanBeUncompact."

	self classBuilder becomeUncompact: self! !

!ClassBuilder methodsFor: '*SlotIntegrationInPharo30-compact classes' stamp: 'MartinDias 8/7/2013 17:30'!
becomeCompact: aClass
	"Make the class compact.
	This means: 
	- find a free slot in 'Smalltalk compactClassArray'
	- add the class in that array
	- update the format of the class with the index
	- update the instances of the class
	"
	| compactClassesArray index |

	aClass isWeak ifTrue: [^ Halt halt: 'You must not make a weak class compact'].
	compactClassesArray := Smalltalk compactClassesArray.
	(aClass isCompact or: [compactClassesArray includes: aClass])
		ifTrue: [^ self halt: aClass name , 'is already compact'].
	index := compactClassesArray indexOf: nil
		ifAbsent: [^ self halt: 'compact class table is full'].
	"Install this class in the compact class table"
	compactClassesArray at: index put: aClass.
	"Update instspec so future instances will be compact"
	aClass setFormat: aClass format + (index bitShift: 11).
	"Make up new instances and become old ones into them"
	aClass updateInstancesFrom: aClass.
	"Purge any old instances"
	Smalltalk garbageCollect.! !

!ClassBuilder methodsFor: '*SlotIntegrationInPharo30-compact classes' stamp: 'MartinDias 8/7/2013 17:31'!
becomeCompact: aClass simplyAt: index
	"The same as #becomeCompact: but without updating the instances."

	| compactClassesArray |
	aClass isWeak ifTrue: [^ Halt halt: 'You must not make a weak class compact'].
	compactClassesArray := Smalltalk compactClassesArray.
	(aClass isCompact or: [compactClassesArray includes: aClass])
		ifTrue: [^ self halt: aClass name, 'is already compact'].		
	(compactClassesArray at: index) ifNotNil: [^ self halt: 'compact table slot already in use'].
	"Install this class in the compact class table"
	compactClassesArray at: index put: aClass.
	"Update instspec so future instances will be compact"
	aClass setFormat: aClass format + (index bitShift: 11).
	"Caller must convert the instances"
! !

!ClassBuilder methodsFor: '*SlotIntegrationInPharo30-compact classes' stamp: 'MartinDias 8/7/2013 17:31'!
becomeUncompact: aClass
	"The inverse of #becomeCompact. However, some classes can not be uncompact: see #checkCanBeUncompact."

	| compactClassesArray index |
	compactClassesArray := Smalltalk compactClassesArray.
	(index := aClass indexIfCompact) = 0
		ifTrue: [^ self].
	(compactClassesArray includes: aClass)
		ifFalse: [^ self halt  "inconsistent state"].
	aClass checkCanBeUncompact.
	"Update instspec so future instances will not be compact"
	aClass setFormat: aClass format - (index bitShift: 11).
	"Make up new instances and become old ones into them"
	aClass updateInstancesFrom: aClass.
	"Make sure there are no compact ones left around"
	Smalltalk garbageCollect.
	"Remove this class from the compact class table"
	compactClassesArray at: index put: nil.
! !
